Device = 16F628A                    '                        /
Xtal = 4                            '                           /
Declare Create_Coff = On            '   Coff   /
'   ///////////////////////////////////////////////////
Declare		SCL_Pin	= PORTB.0       '    SCL_I2C      /
Declare     SDA_Pin	= PORTB.1       '    SDA_I2C      /
'   ////////////////////////////////////////////////////
Dim D_LCD      As Byte              '    LSD        /
Dim D_LCD_H    As Byte              '                    /
Dim E          As D_LCD.3           '  3 bit   LCD /
Dim RS         As D_LCD.2           '  2 Bit  RegSell LCD/
Dim LED_LCD    As Bit               ' Bit          /
Dim N_STRING   As Byte              '        /
Dim STR_LCD[20]As Byte              '     LCD /
Dim X_LCD      As Byte              '              /
Dim Y_LCD      As Byte              '            /

TRISB = 0
'   //////////////////////////////////////////////
GoSub LCD_I2C_INIT                  '  LCD                /
'///////////////////////////////////////////////////////////////////////
'//////                 ///////////////////////////////
'///////////////////////////////////////////////////////////////////////
main:                               '                                  /
                                    '                                  /
Y_LCD = 0                           '                   /
X_LCD = 0                           '               /
GoSub LCD_XY                        '         /
                                    '                           /
StrN STR_LCD = "PICBASIC.ru"        '              /                                         
GoSub  LCD_PRINT                    '   LCD                /
'Dim UB1 As Word                    '             /
'UB1 = 1234                         '                        /
'StrN STR_LCD = Str$(Dec UB1)       '                                  /
'GoSub LCD_PRINT                    '                                  /
                                    '                                  /
Y_LCD = 1                           '                                  /
X_LCD = 4                           '                                  /
GoSub LCD_XY                        '                                  /
                                    '                                  /
StrN STR_LCD = "Hello World"         '                                  /  
GoSub  LCD_PRINT                    '                                  /
                                    '                                  /
DelayMS 2000                        '                                  /
'LED_LCD = ~LED_LCD                 '        /
GoTo main                           '                                  /
'///////////////////////////////////////////////////////////////////////
'//////                 //////////////////////////
'///////////////////////////////////////////////////////////////////////
LCD_I2C_INIT:                       '                                  /  
  BStart                            '   I2C               /
  BusOut %01001110                  '  PCF8574 - 000              /
  BusOut %00000000                  '                       /  
  BStop                             '   I2C               /              
  DelayMS 20                        '     LCD
'//////          1        ////////////////
  D_LCD = %00110000;                '  1                            /
  RS = 0;                           ' RS  0 -            /
  GoSub LCD_SEND_N                  '   lCD                  /               
  DelayMS 4                         '               / 
                                    '  2                            /    
  D_LCD = %00100000;                '                                  /
  RS = 0;                           '                                  /
  GoSub LCD_SEND_N                  '                                  /
'//////          2        ////////////////
  D_LCD = %00110000;                '  1                            /
  RS = 0;                           ' RS  0 -            /
  GoSub LCD_SEND_N                  '   lCD                  /               
  DelayUS 100                       '               / 
                                    '  2                            /    
  D_LCD = %00100000;                '                                  /
  RS = 0;                           '                                  /
  GoSub LCD_SEND_N                  '                                  /
'//////          3        ////////////////
  D_LCD = %00110000;                '  1                            /
  RS = 0;                           ' RS  0 -            /
  GoSub LCD_SEND_N                  '   lCD                  /               
  DelayUS 1                         '               / 
                                    '  2                            /    
  D_LCD = %00100000;                '                                  /
  RS = 0;                           '                                  /
  GoSub LCD_SEND_N                  '                                  /  
'///////            4    2     //////
  D_LCD = %00100000;                '  3         /
  RS = 0;                           '                                  /
  GoSub LCD_SEND_N                  '                                  /
  D_LCD = %10000000;                '               /
  RS = 0;                           '                                  /
  GoSub LCD_SEND_N                  '                                  /
  DelayMS 4                         '                                  /
'///////          LCD       ////////////////////////////////////
  D_LCD = %00000000;                '  4                            / 
  RS = 0;                           '                                  /
  GoSub LCD_SEND_N                  '                                  /
  D_LCD = %11000000;                ' 2bit - on/off,3bit-,4bit-  /
  RS = 0;                           '                    /
  GoSub LCD_SEND_N                  '                                  /    
'///////                 ////////////////////////////
  D_LCD = %00000000;                '  5                            /
  RS = 0;                           '                                  /
  GoSub LCD_SEND_N                  '                                  /
  D_LCD = %01100000;                '                                  /
  RS = 0;                           '                                  /
  GoSub LCD_SEND_N                  '                                  /
  DelayMS 4                         '                                  /
Return                              '                      /                                  
'///////////////////////////////////////////////////////////////////////
'//////        /////////////////////////
'///////////////////////////////////////////////////////////////////////
LCD_SEND_N:                         '                                  / 
  BStart                            '   I2C               /
  BusOut %01001110                  '  PCF8574 - 000              /     
  BusOut D_LCD                      '    LCD           /
  E = 1                             '    1                      /
  BusOut D_LCD                      '                     /
  DelayUS 5                         '    LCD       /
  E = 0                             '    0                      /
  BusOut D_LCD                      '                     /
  BStop                             '   I2C               /   
Return                              '                      / 
'///////////////////////////////////////////////////////////////////////
'////////              LCD           //////////
'///////////////////////////////////////////////////////////////////////
LCD_PRINT:                          '                                  / 
  For N_STRING = 0 To 20            '     /
  D_LCD = STR_LCD[N_STRING]         '    D_LCD     /
  If  D_LCD = 0 Then Break          '            /
                                    '                     /
  D_LCD_H = D_LCD << 4              '    /
                                    '         /
                                    '   RS        /
                                    '                        /
  RS = 1                            '             /
  D_LCD.0 = LED_LCD                 '     /
  GoSub LCD_SEND_N                  '    LCD           /
  D_LCD = D_LCD_H                   '         /
  RS = 1                            '                       /
  D_LCD.0 = LED_LCD                 '                    /
  GoSub LCD_SEND_N                  '     LCD/
  Next                              '                        /
Return                              '                      /
'///////////////////////////////////////////////////////////////////////
'//////        /////////////////////////
'///////////////////////////////////////////////////////////////////////
LCD_XY:                             '                                  /
  D_LCD = 0x40* Y_LCD + X_LCD       '         /
  D_LCD.7 = 1                       '       /
                                    '                 /
  D_LCD_H = D_LCD << 4              '            /
  RS = 0                            '            /
  D_LCD.0 = LED_LCD                 '     /
  GoSub LCD_SEND_N                  '    LCD           /
  D_LCD = D_LCD_H                   '         /
  RS = 0                            '            /
  D_LCD.0 = LED_LCD                 '     /
  GoSub LCD_SEND_N                  '    LCD           /
Return                              '                      /
'///////////////////////////////////////////////////////////////////////     

